#include <stdio.h>
#include <math.h>
#include "myvga.h"
#include "skel.h"

/*  In this test, I test a dumb approach to drawing every pixel on a low
        resolution screen.  In this case, 320x200, 8 bitplanes
*/
void draw_skel(camera *cam, simple_triangle_list *stl, simple_point_list *spl)
{
        int x1, y1, x2, y2, x3, y3, t;
	real theta;
	char c;
        v3 trans;
	d2 ta, tb, tc;
        int xres, yres, xres_1, yres_1, color;

	simple_point_list *p_list;
	simple_triangle_list *tri_list;

        printf("hello, world\n");

	xres = cam->xres;
	yres = cam->yres;
	xres_1 = xres - 1;
	yres_1 = yres - 1;
	
	p_list = spl;
	while (p_list != NULL)
	{
		p_list = p_list->next;
	}

	theta = 0.0;
	c = ' ';
	while (  (c = my_vga_getkey()) != 'q')
	{
		switch (c) {
		case '8': cam->position = cam->position + 
			v3_scalar_mul(0.9, cam->forward);
			break;
		case '2': cam->position = cam->position - 
			v3_scalar_mul(0.9, cam->forward);
			break;
		case '1': theta += 0.1;
			cam->up = cam->up -
				v3_scalar_mul(0.1, cam->fxu);
			break;
		case '3': theta -= 0.1;
			cam->up = cam->up +
				v3_scalar_mul(0.1, cam->fxu);
			break;
		case '4': theta += 0.1;
			cam->forward = cam->forward -
				v3_scalar_mul(0.01, cam->fxu);
			break;
		case '6': theta -= 0.1;
			cam->forward = cam->forward +
				v3_scalar_mul(0.01, cam->fxu);
			break;
		case 'a': cam->position = cam->position + 
				v3_scalar_mul(0.3, cam->up);
			break;
		case 'z': cam->position = cam->position - 
				v3_scalar_mul(0.3, cam->up);
			break;
		case 's': cam->forward = cam->forward + 
				v3_scalar_mul(0.01, cam->up);
			break;
		case 'x': cam->forward = cam->forward - 
				v3_scalar_mul(0.01, cam->up);
			break;
		case ' ': my_vga_dumpscreen();
			break;
		default:  
			 break;
		}

		//cam->position.x = sin(theta) * 9.0;
		//cam->position.z = - cos(theta) * 9.0;
		cam->make_m3();

		p_list = spl;
		while (p_list != NULL)
		{
                        // trans = p_list->p->pt;
                        cam->cam_trans(&p_list->p->pt, p_list->p->trans);
			//if (p_list->p->trans->z > 0.0) {
			if (1) {
                                cam->cam_proj(p_list->p->trans,
					&p_list->p->project );
				p_list->p->drawable = 'y';
			}
			else
				p_list->p->drawable = 'n';
			p_list = p_list->next;
		} 
		my_vga_clear();
                my_vga_setcolor(1);
                my_vga_drawline(  0,  0,xres_1,  0, 22);
                my_vga_drawline(  0,  0,  0,yres_1, 22);
                my_vga_drawline(xres_1,  0,xres_1,yres_1, 22);
                my_vga_drawline(  0,yres_1,xres_1,yres_1, 22);
		tri_list = stl;
		while (tri_list != NULL)
		{
		 //if (my_vga_getkey() == 'p') while (my_vga_getkey() != 'r') ;
			//if (v3_dot(tri_list->tri->normal, cam->forward) > 0.0) 
			{
				ta = tri_list->tri->a->project;
				tb = tri_list->tri->b->project;
				tc = tri_list->tri->c->project;

				if ((tri_list->tri->a->drawable == 'y') && 
			             (tri_list->tri->b->drawable == 'y') && 
				     (tri_list->tri->c->drawable == 'y'))  {
					x1 =  ta.x;
					y1 =  ta.y;
					x2 =  tb.x;
					y2 =  tb.y;
					x3 =  tc.x;
					y3 =  tc.y;
					x2 = (x2 < 0 )? 0 : x2;
					x2 = (x2 > xres)? xres -1 : x2;
					x3 = (x3 < 0 )? 0 : x3;
					x3 = (x3 > xres)? xres -1 : x3;
					x1 = (x1 < 0 )? 0 : x1;
					x1 = (x1 > xres)? xres -1 : x1;
					y2 = (y2 < 0 )? 0 : y2;
					y2 = (y2 > yres)? yres -1 : y2;
					y3 = (y3 < 0 )? 0 : y3;
					y3 = (y3 > yres)? yres -1 : y3;
					y1 = (y1 < 0 )? 0 : y1;
                                        y1 = (y1 > yres)? yres -1 : y1;   
                                        color = tri_list->tri->color;
                                        my_vga_drawline(  x1, y1, x2, y2, color);
                                        my_vga_drawline(  x1, y1, x3, y3, color);
                                        my_vga_drawline(  x3, y3, x2, y2, color);
				//	for (color = 0; color < 256; color++)
	                         //               my_vga_drawline(  color, 0,
				//				  color, 10,
				//				  color);
				} // if dot prod.
			}
			tri_list = tri_list->next;
		} // while triangles 
	} // while not q
}
